//
//  HeadersH2CaretLinkModel.swift
//  MVMCoreUI
//
//  Created by Lekshmi S on 01/07/20.
//  Copyright © 2020 Verizon Wireless. All rights reserved.
//

import Foundation
public class HeadersH2CaretLinkModel: HeaderModel, MoleculeModelProtocol {
    //--------------------------------------------------
    // MARK: - Properties
    //--------------------------------------------------
    public static var identifier: String = "headerH2CrtBtn"
    public var headlineBody: HeadlineBodyModel
    public var caretLink: CaretLinkModel
    
    //--------------------------------------------------
    // MARK: - Initializer
    //--------------------------------------------------
    public init(headlineBody: HeadlineBodyModel, caretLink: CaretLinkModel) {
        self.headlineBody = headlineBody
        self.caretLink = caretLink
        super.init()
    }
    
    //--------------------------------------------------
    // MARK: - Methods
    //--------------------------------------------------
    public override func setDefaults() {
        if topPadding == nil {
            topPadding = Padding.Component.VerticalMarginSpacing
        }
        if bottomPadding == nil {
            bottomPadding = Padding.Component.VerticalMarginSpacing
        }
        super.setDefaults()
    }
    
    //--------------------------------------------------
    // MARK: - Keys
    //--------------------------------------------------
    private enum CodingKeys: String, CodingKey {
        case moleculeName
        case headlineBody
        case caretLink
    }
    
    //--------------------------------------------------
    // MARK: - Codec
    //--------------------------------------------------
    required public init(from decoder: Decoder) throws {
        let typeContainer = try decoder.container(keyedBy: CodingKeys.self)
        headlineBody = try typeContainer.decode(HeadlineBodyModel.self, forKey: .headlineBody)
        caretLink = try typeContainer.decode(CaretLinkModel.self, forKey: .caretLink)
        try super.init(from: decoder)
    }
    
    public override func encode(to encoder: Encoder) throws {
        try super.encode(to: encoder)
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(moleculeName, forKey: .moleculeName)
        try container.encode(headlineBody, forKey: .headlineBody)
        try container.encode(caretLink, forKey: .caretLink)
    }
}
